<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:r="http://recipes.org">
    
    <xsl:output method="xml"
                doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
                doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
                encoding="UTF-8"
                indent="yes"
    />
    
    <!-- 
     Please complete the stylesheet. You can change whatever you like.
     For task instructions, read the comments in XSLTProcesor.java in this project.
     Hints are in comments in this file.
    -->
    <!-- See the usage of namespaces in the XPath expression in "match" -->
    <xsl:template match="/r:collection">
        <html>
            <head>
                <title>Collection of Recipes</title>
                <meta http-equiv="Content-Style-Type" content="text/css" />
                <link rel="stylesheet" href="recipes.css" type="text/css" media="screen" />  
            </head>
            <body>
                <h1>Collection of Recipes</h1>
                <hr/>
                <h2>List of Recipes</h2>
                <ul>
                <!-- Apply templates with "mode" for generating 
                    the list of links to recipes -->
                <xsl:apply-templates select="r:recipe" mode="link_to_recipe"/>
                </ul>
                <h2>Recipes</h2>
                <!-- Apply templates without "mode" for generating list of recipes -->
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="r:recipe">
        <div><hr/>
        <!-- use the Xpath function generate-id to generate id for linking -->
            <a name="{generate-id(.)}" id="{generate-id(.)}"/>
            <h3>
            <xsl:apply-templates select="r:title"/>
            </h3>
            <!-- complete the template -->
        </div>
    </xsl:template>
    
    <xsl:template match="r:recipe" mode="link_to_recipe">
        <li>
            <!-- use the Xpath function generate-id to generate id for linking -->
            <a href="#{generate-id(.)}">
                <!-- complete the template -->
            </a>
        </li>
    </xsl:template>
    
    <xsl:template match='r:ingredient'>
        <!-- complete the template -->
    </xsl:template>

    <!-- add templates -->
</xsl:stylesheet>
