package cz.muni.fi.pb138.spring2019.task3;


import java.io.File;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
 * Task 3, XSL Transformations (XSLT)
 * 
 * Your task is to complete the recipes-to-html.xsl stylesheet
 * so that it defines a transformation from recipes.xml to recipes.html
 * so that its output is a) valid XHTML or HTML5 and 
 * b) has its content similar to provided recipes-should-look-like.html
 * 
 * Principal rules for the output are:
 * 1) there is a list of links to all recipes on top of the page
 * 2) for each recipe, there is a section with a heading. 
 * The section contains ingredients and preparation steps for this recipe.
 * Note that ingredients can be nested, eg. Ricotta Pie contains filling, dough, 
 * and milk where filling and dough compound of another (primary) ingredients.
 * 
 * For testing the transformation, you can either 
 * a) run this file directly in NetBeans or simply in Java, or
 * b) do the transformation by clicking the right arrow icon/button 
 * in NetBeans when the recipes-to-html.xsl is open, or
 * b) use some other XSLT transformation engine such as xsltproc.
 * 
 * @author bar, tomp 2019
 */
public class XSLTProcessor {
    public static void main(String[] args) 
            throws TransformerConfigurationException, TransformerException {
        
        TransformerFactory tf = TransformerFactory.newInstance();
        
        Transformer xsltProc = tf.newTransformer(
                new StreamSource(new File("recipes-to-html.xsl")));
        
        xsltProc.transform(
                new StreamSource(new File("recipes.xml")), 
                new StreamResult(new File("recipes.html")));
    }
}
